﻿from math import*

def barycentre (L):   # en faisant la moyenne des coordonnées on obtient les coordonnées du barycentre
    X=0
    Y=0
    for i in range (len(L)):
        X=X+L[i][0]              #PROBLEME   DE TYPE!!!!!
        Y=Y+L[i][1]
    b = [X/len(L),Y/len(L)]
    return b

def distance(point1,point2) :    # fonction qui permet de calculer une distance entre deux points
    d= sqrt((point1[0]-point2[0])**2+(point1[1]-point2[1])**2)
    return d

def point_le_plus_loin(b,L):    #on cherche le point le plus loin du barycentre, s'il y en a plusieurs, il prend le premier
    pointLoin = 0
    distanceLoin = distance(b,L[0])
    for i in range(1,len(L)):
        distanceTest = distance(b,L[i])
        if distanceTest > distanceLoin :
            pointLoin = i
            distanceLoin = distanceTest
    return pointLoin      #retourne l'indice du point le plus loin dans la liste

def equation_de_la_droite(pointLoin, pointA):          # calcule l'équation d'une droite passant par deux points
    if pointLoin[0]!=pointA[0]:
        a = (pointLoin[1]-pointA[1])/(pointLoin[0]-pointA[0])   #on part sur une équation de la forme "cy=ax+b" où c=1 si elle est réduite et c=0 si droite verticale
        c=1
        b = pointA[1]-a*pointA[0]
    else:   #pour traiter le cas de la droite verticale
        a=1
        c=0
        b = -pointA[0]
    equationDroite=[a,b,c]
    return equationDroite             # "cy=ax+b" retourne en liste le coefficient directeur a et l'ordonnée à l'origine b de l'équation de la droite et c devant le y


def enveloppe(L,pointLoin,decalage):            #données: la liste de points, le point loin et un paramètre décalage
    depart=(pointLoin+decalage)%len(L)
    print(depart,pointLoin)
                         # on prend le point après le poinloin
    test=True
    eq=equation_de_la_droite(L[pointLoin],L[depart])
    print(eq)
                #retourne a et b de la droite passant par point loin et un point situé après.
    A = list(range(len(L))) # on crée une liste momentanée avec les indices des points sauf le point Loin et le point de départ. !!!!
    A.remove(pointLoin)
    A.remove(depart)
    print(A)
    signe=eq[2]*L[A[0]][1]-(eq[0]*L[A[0]][0]+eq[1])    #on calcule cy - (ax+b) avec le 1er point qui n'est pas sur la droite !!!!!!

    compteur=1
    while test and compteur<=len(L)-3:
        calcul=  eq[2]*L[A[compteur]][1]- (eq[0]*L[A[compteur]][0]+eq[1])   # on calcule la valeur de cy - (ax+b) avec le point suivant de la liste A !!!!!

        if calcul*signe<0:    #s'ils n'ont pas le même signe alors le test a échoué sinon on continue
            test=False
        compteur+=1

    return(test)  #dans tous les cas à la fin on retourne le test qui restera true si pas de souci et sera passé à false si incohérence des signes

def processus():  #on lance le processus jusqu'à ce qu'une droite soit trouvée
    decalage=1
    while enveloppe(L,pointLoin,decalage)==False:
        decalage+=1
    return(decalage)  #retourne l'indice qui a fonctionné soit la position du point à relier à pointloin pour assurer la convexité!


# ensuite il faut itérer le procédé pour tracer TOUTE L'ENVELOPPE CONVEXE

#le nouveau pointloin est celui du décalage et on recommence





#PARTIE GRAPHIQUE DU PROGRAMME
import pygame,sys
from pygame.locals import*

pygame.init()
largeur=500
longueur=500
fenetre=pygame.display.set_mode((longueur,largeur),0,32)
fenetre.fill((255,255,255))

L=[]
i=0

blue=(0,0,255)
white=(255,255,255)
red=(255,0,0)
basicFont=pygame.font.SysFont(None,20)

text1=basicFont.render('Polygone',True,blue,white)
text1Rect=text1.get_rect()
text1Rect.centerx=455
text1Rect.centery=115

rect1=pygame.draw.rect(fenetre,blue,(text1Rect.left-5,text1Rect.top-10,text1Rect.width+10,text1Rect.height+20 ),2)

fenetre.blit(text1,text1Rect)


text2=basicFont.render('Enveloppe',True,red,white)
text2Rect=text1.get_rect()
text2Rect.centerx=455
text2Rect.centery=180

rect2=pygame.draw.rect(fenetre,red,(text2Rect.left-5,text2Rect.top-10,text2Rect.width+10,text2Rect.height+20 ),2)

fenetre.blit(text2,text2Rect)


while True:
    for event in pygame.event.get():
        if event.type==QUIT:
            pygame.quit()
            sys.exit()

        if event . type == MOUSEBUTTONDOWN  and event.button ==1 and event.button ==1 and not rect1.collidepoint(event.pos) and not rect2.collidepoint(event.pos) :
            nouveau_point=pygame.mouse.get_pos()
            L.append([nouveau_point[0],nouveau_point[1]])
            if len(L)!=1:
                pygame.draw.line(fenetre,(0,255,0),L[i],L[i+1])
                i+=1
        if event . type == MOUSEBUTTONDOWN  and event.button ==1 and rect1.collidepoint(event.pos):
            pygame.draw.polygon(fenetre,(0,255,0),L,0)
            print("La liste des points est", L)
        if event . type == MOUSEBUTTONDOWN  and event.button ==1 and rect2.collidepoint(event.pos):
            b=barycentre(L)
            print("Le barycentre est",b)
            pointLoin=point_le_plus_loin(b,L)  #indice du point Loin
            print("Le point Loin a pour coordonnée",pointLoin)
            enveloppe_finale=[L[pointLoin]]  #on initialise l'enveloppe avec le premier point qui est le point Loin
            while enveloppe_finale.count(L[pointLoin])==1:   #on attend que le point Loin soit choisi à nouveau dans notre enveloppe pour dire qu'on a bouclé et
                #qu'on a fini l'enveloppe
                p=processus()
                print("le décalage appliquée est",p)
                enveloppe_finale.append(L[(pointLoin+p)%len(L)])
                pointLoin=(pointLoin+p)%len(L)
            print("enveloppe",enveloppe_finale)
            pygame.draw.polygon(fenetre,(255,0,0),enveloppe_finale,2)

    pygame.display.update()


